// Percussion Synth globals

#define AUDIO_SAMPLE_RATE 22000 // Hz
// 16 bit mono sound sample buffer
// @ 22 KHz = ~5.8 msec
// @ 44 KHz = ~2.9 msec
#define SOUND_BLOCK_SIZE 128    // same as Teensy
// 2x audio sample buffers in circular buffer
// 2x stereo interleaved data
#define DMA_BUFSIZ (SOUND_BLOCK_SIZE*4) // words

// current UI sensor state
struct ui_controls_struct
{
  byte band_knob;   // pitch
  byte wave_knob;   // instrument
  byte effect_knob; // proximity effect
  byte proximity;   // proximity
};

// instruments configuration
#define WT_WAVE   0
#define WT_STRING 1
#define WT_DRUM   2

// in main
extern const float notes_octave[7];
extern const int16_t *wavetable[3];

