#ifndef synth_drum_h_
#define synth_drum_h_

#define NBR_DRUM_EFFECTS 5

class synth_instrument_drum
{
  public:
  
    synth_instrument_drum()
    {
      length(600);
      frequency(60);
      pitchMod(0x200);
      wav_amplitude1 = 0x7fff;
      wav_amplitude2 = 0;
    }

    void frequency(float freq);
    void length(int32_t milliseconds);
    void secondMix(float level);
    void pitchMod(float depth);
    
    void startInstrument( ui_controls_struct *ui, int key );
    void updateInstrument( ui_controls_struct *ui );
    byte runInstrument( int32_t *buf );
    void stopInstrument();
  
  private:

    // Envelope params
    int32_t env_lin_current; // present value of linear slope.
    int32_t env_decrement;   // how each sample deviates from previous.
  
    // Waveform params
    uint32_t wav_phasor;      
    uint32_t wav_phasor2;     
    
    int16_t wav_amplitude1;
    int16_t wav_amplitude2;
    
    uint32_t wav_increment;
    int32_t  wav_pitch_mod;
};

#endif

